Index: tmp/org.txm.backtomedia.rcp/src/org/txm/backtomedia/commands/function/TripleRangeSlider.java
===================================================================
--- tmp/org.txm.backtomedia.rcp/src/org/txm/backtomedia/commands/function/TripleRangeSlider.java	(revision 2420)
+++ tmp/org.txm.backtomedia.rcp/src/org/txm/backtomedia/commands/function/TripleRangeSlider.java	(revision 2421)
@@ -45,32 +45,55 @@
  * </p>
  */
 public class TripleRangeSlider extends Canvas {
-
-	public enum SELECTED_KNOB {NONE, UPPER, LOWER, MIDDLE  };
-
+	
+	public enum SELECTED_KNOB {
+		NONE, UPPER, LOWER, MIDDLE
+	};
+	
 	private int minimum;
+	
 	private int maximum;
+	
 	private int lowerValue;
+	
 	private int middleValue;
+	
 	private int upperValue;
+	
 	private final List<SelectionListener> listeners;
+	
 	private final Image slider, sliderHover, sliderDrag, sliderSelected;
+	
 	private final Image vSlider, vSliderHover, vSliderDrag, vSliderSelected;
+	
 	private int orientation;
+	
 	private int increment;
+	
 	private int pageIncrement;
+	
 	private SELECTED_KNOB lastSelected;
+	
 	private boolean dragInProgress;
+	
 	private Point coordUpper;
+	
 	private boolean upperHover;
+	
 	private Point coordMiddle;
+	
 	private boolean middleHover;
+	
 	private Point coordLower;
+	
 	private boolean lowerHover;
+	
 	private int previousUpperValue;
+	
 	private int previousMiddleValue;
+	
 	private int previousLowerValue;
-
+	
 	/**
 	 * Constructs a new instance of this class given its parent and a style
 	 * value describing its behavior and appearance.
@@ -87,10 +110,12 @@
 	 *            instance (cannot be null)
 	 * @param style the style of control to construct
 	 *
-	 * @exception IllegalArgumentException <ul>
+	 * @exception IllegalArgumentException
+	 *                <ul>
 	 *                <li>ERROR_NULL_ARGUMENT - if the parent is null</li>
 	 *                </ul>
-	 * @exception SWTException <ul>
+	 * @exception SWTException
+	 *                <ul>
 	 *                <li>ERROR_THREAD_INVALID_ACCESS - if not called from the
 	 *                thread that created the parent</li>
 	 *                </ul>
@@ -109,85 +134,92 @@
 		this.sliderHover = new Image(getDisplay(), this.getClass().getClassLoader().getResourceAsStream("images/slider-hover.png")); //$NON-NLS-1$
 		this.sliderDrag = new Image(getDisplay(), this.getClass().getClassLoader().getResourceAsStream("images/slider-drag.png")); //$NON-NLS-1$
 		this.sliderSelected = new Image(getDisplay(), this.getClass().getClassLoader().getResourceAsStream("images/slider-selected.png")); //$NON-NLS-1$
-
+		
 		this.vSlider = new Image(getDisplay(), this.getClass().getClassLoader().getResourceAsStream("images/h-slider-normal.png")); //$NON-NLS-1$
 		this.vSliderHover = new Image(getDisplay(), this.getClass().getClassLoader().getResourceAsStream("images/h-slider-hover.png")); //$NON-NLS-1$
 		this.vSliderDrag = new Image(getDisplay(), this.getClass().getClassLoader().getResourceAsStream("images/h-slider-drag.png")); //$NON-NLS-1$
 		this.vSliderSelected = new Image(getDisplay(), this.getClass().getClassLoader().getResourceAsStream("images/h-slider-selected.png")); //$NON-NLS-1$
-
+		
 		if ((style & SWT.VERTICAL) == SWT.VERTICAL) {
 			this.orientation = SWT.VERTICAL;
-		} else {
+		}
+		else {
 			this.orientation = SWT.HORIZONTAL;
 		}
-
+		
 		this.addListener(SWT.Dispose, new Listener() {
+			
 			@Override
 			public void handleEvent(final Event event) {
 				SWTGraphicUtil.dispose(TripleRangeSlider.this.slider);
 				SWTGraphicUtil.dispose(TripleRangeSlider.this.sliderHover);
 				SWTGraphicUtil.dispose(TripleRangeSlider.this.sliderDrag);
 				SWTGraphicUtil.dispose(TripleRangeSlider.this.sliderSelected);
-
+				
 				SWTGraphicUtil.dispose(TripleRangeSlider.this.vSlider);
 				SWTGraphicUtil.dispose(TripleRangeSlider.this.vSliderHover);
 				SWTGraphicUtil.dispose(TripleRangeSlider.this.vSliderDrag);
 				SWTGraphicUtil.dispose(TripleRangeSlider.this.vSliderSelected);
 			}
 		});
-
+		
 		addMouseListeners();
 		addListener(SWT.KeyDown, new Listener() {
-
+			
 			@Override
 			public void handleEvent(final Event event) {
 				handleKeyDown(event);
 			}
 		});
 		addPaintListener(new PaintListener() {
+			
 			@Override
 			public void paintControl(final PaintEvent e) {
 				drawWidget(e);
-
+				
 			}
 		});
-
+		
 	}
-
+	
 	/**
 	 * Add the mouse listeners (mouse up, mouse down, mouse move, mouse wheel)
 	 */
 	private void addMouseListeners() {
 		addListener(SWT.MouseDown, new Listener() {
+			
 			@Override
 			public void handleEvent(final Event e) {
 				handleMouseDown(e);
 			}
 		});
-
+		
 		addListener(SWT.MouseUp, new Listener() {
+			
 			@Override
 			public void handleEvent(final Event e) {
 				handleMouseUp(e);
 			}
 		});
-
+		
 		addListener(SWT.MouseMove, new Listener() {
+			
 			@Override
 			public void handleEvent(final Event e) {
 				handleMouseMove(e);
 			}
 		});
-
+		
 		addListener(SWT.MouseWheel, new Listener() {
+			
 			@Override
 			public void handleEvent(final Event e) {
 				handleMouseWheel(e);
 			}
 		});
-
+		
 	}
-
+	
 	/**
 	 * Code executed when the mouse is down
 	 *
@@ -199,24 +231,27 @@
 			this.dragInProgress = true;
 			this.lastSelected = SELECTED_KNOB.UPPER;
 			this.previousUpperValue = this.upperValue;
-		} else if (this.lowerHover) {
+		}
+		else if (this.lowerHover) {
 			this.dragInProgress = true;
 			this.lastSelected = SELECTED_KNOB.LOWER;
 			this.previousLowerValue = this.lowerValue;
-		} else if (this.middleHover) {
+		}
+		else if (this.middleHover) {
 			this.dragInProgress = true;
 			this.lastSelected = SELECTED_KNOB.MIDDLE;
 			this.previousMiddleValue = this.middleValue;
-		} else {
+		}
+		else {
 			this.dragInProgress = true;
-			//this.lastSelected = SELECTED_KNOB.NONE;
+			// this.lastSelected = SELECTED_KNOB.NONE;
 			this.lastSelected = SELECTED_KNOB.MIDDLE;
 			this.previousMiddleValue = this.middleValue;
 			handleMouseMove(e);
 		}
-		//System.out.println("MouseDown : "+lastSelected);
+		// System.out.println("MouseDown : "+lastSelected);
 	}
-
+	
 	/**
 	 * Code executed when the mouse is up
 	 *
@@ -231,16 +266,18 @@
 			if (this.lastSelected == SELECTED_KNOB.UPPER) {
 				this.upperValue = this.previousUpperValue;
 				if (this.middleValue > this.upperValue) this.middleValue = upperValue;
-			} else if (this.lastSelected == SELECTED_KNOB.LOWER) {
+			}
+			else if (this.lastSelected == SELECTED_KNOB.LOWER) {
 				this.lowerValue = this.previousLowerValue;
 				if (this.middleValue < this.lowerValue) this.middleValue = lowerValue;
-			} else {
+			}
+			else {
 				this.middleValue = this.previousMiddleValue;
 			}
 			redraw();
 		}
 	}
-
+	
 	/**
 	 * Fire all selection listeners
 	 *
@@ -258,7 +295,7 @@
 		}
 		return true;
 	}
-
+	
 	/**
 	 * Code executed when the mouse pointer is moving
 	 *
@@ -270,39 +307,44 @@
 		this.upperHover = x >= this.coordUpper.x && x <= this.coordUpper.x + img.getBounds().width && y >= this.coordUpper.y && y <= this.coordUpper.y + img.getBounds().height;
 		this.middleHover = x >= this.coordMiddle.x && x <= this.coordMiddle.x + img.getBounds().width && y >= this.coordMiddle.y && y <= this.coordMiddle.y + img.getBounds().height;
 		this.lowerHover = x >= this.coordLower.x && x <= this.coordLower.x + img.getBounds().width && y >= this.coordLower.y && y <= this.coordLower.y + img.getBounds().height;
-
+		
 		if (this.dragInProgress) {
 			if (this.orientation == SWT.HORIZONTAL) {
 				final int mouseValue = (int) ((x - 9f) / computePixelSizeForHorizonalSlider()) + this.minimum;
 				if (this.lastSelected == SELECTED_KNOB.UPPER) {
 					this.upperValue = (int) (Math.ceil(mouseValue / this.increment) * this.increment) - this.increment;
 					checkUpperValue();
-				} else if (this.lastSelected == SELECTED_KNOB.LOWER) {
+				}
+				else if (this.lastSelected == SELECTED_KNOB.LOWER) {
 					this.lowerValue = (int) (Math.ceil(mouseValue / this.increment) * this.increment) - this.increment;
 					checkLowerValue();
-				} else {
+				}
+				else {
 					this.middleValue = (int) (Math.ceil(mouseValue / this.increment) * this.increment) - this.increment;
 					checkMiddleValue();
 				}
-
-			} else {
+				
+			}
+			else {
 				final int mouseValue = (int) ((y - 9f) / computePixelSizeForVerticalSlider()) + this.minimum;
 				if (this.lastSelected == SELECTED_KNOB.UPPER) {
 					this.upperValue = (int) (Math.ceil(mouseValue / this.increment) * this.increment) - this.increment;
 					checkUpperValue();
-				} else if (this.lastSelected == SELECTED_KNOB.LOWER) {
+				}
+				else if (this.lastSelected == SELECTED_KNOB.LOWER) {
 					this.lowerValue = (int) (Math.ceil(mouseValue / this.increment) * this.increment) - this.increment;
 					checkLowerValue();
-				} else {
+				}
+				else {
 					this.middleValue = (int) (Math.ceil(mouseValue / this.increment) * this.increment) - this.increment;
 					checkMiddleValue();
 				}
 			}
 		}
-
+		
 		redraw();
 	}
-
+	
 	/**
 	 * Code executed when the mouse wheel is activated
 	 *
@@ -312,22 +354,24 @@
 		if (this.lastSelected == SELECTED_KNOB.NONE) {
 			return;
 		}
-
+		
 		if (this.lastSelected == SELECTED_KNOB.LOWER) {
 			this.lowerValue += e.count * this.increment;
 			checkLowerValue();
 			redraw();
-		} else if (this.lastSelected == SELECTED_KNOB.UPPER) {
+		}
+		else if (this.lastSelected == SELECTED_KNOB.UPPER) {
 			this.upperValue += e.count * this.increment;
 			checkUpperValue();
 			redraw();
-		} else {
+		}
+		else {
 			this.middleValue += e.count * this.increment;
 			checkMiddleValue();
 			redraw();
 		}
 	}
-
+	
 	/**
 	 * Check if the lower value is in ranges
 	 */
@@ -354,7 +398,7 @@
 			this.middleValue = this.upperValue;
 		}
 	}
-
+	
 	/**
 	 * Check if the upper value is in ranges
 	 */
@@ -369,7 +413,7 @@
 			this.upperValue = this.lowerValue;
 		}
 	}
-
+	
 	/**
 	 * Draws the widget
 	 *
@@ -384,12 +428,13 @@
 		e.gc.setAntialias(SWT.ON);
 		if (this.orientation == SWT.HORIZONTAL) {
 			drawHorizontalRangeSlider(e.gc);
-		} else {
+		}
+		else {
 			drawVerticalRangeSlider(e.gc);
 		}
-
+		
 	}
-
+	
 	/**
 	 * Draw the range slider (horizontal)
 	 *
@@ -402,7 +447,7 @@
 		this.coordMiddle = drawHorizontalKnob(gc, this.middleValue, SELECTED_KNOB.MIDDLE);
 		this.coordLower = drawHorizontalKnob(gc, this.lowerValue, SELECTED_KNOB.LOWER);
 	}
-
+	
 	/**
 	 * Draw the background
 	 *
@@ -410,36 +455,38 @@
 	 */
 	private void drawBackgroundHorizontal(final GC gc) {
 		final Rectangle clientArea = this.getClientArea();
-
+		
 		gc.setBackground(getBackground());
 		gc.fillRectangle(clientArea);
-
+		
 		if (isEnabled()) {
 			gc.setForeground(getForeground());
-		} else {
+		}
+		else {
 			gc.setForeground(getDisplay().getSystemColor(SWT.COLOR_GRAY));
 		}
 		gc.drawRoundRectangle(9, 9, clientArea.width - 20, clientArea.height - 20, 3, 3);
-
+		
 		final float pixelSize = computePixelSizeForHorizonalSlider();
 		final int startX = (int) (pixelSize * this.lowerValue);
 		final int endX = (int) (pixelSize * this.upperValue);
 		if (isEnabled()) {
 			gc.setBackground(getForeground());
-		} else {
+		}
+		else {
 			gc.setBackground(getDisplay().getSystemColor(SWT.COLOR_GRAY));
 		}
 		gc.fillRectangle(12 + startX, 9, endX - startX - 6, clientArea.height - 20);
-
+		
 	}
-
+	
 	/**
 	 * @return how many pixels corresponds to 1 point of value
 	 */
 	private float computePixelSizeForHorizonalSlider() {
 		return (getClientArea().width - 20f) / (this.maximum - this.minimum);
 	}
-
+	
 	/**
 	 * Draw the bars
 	 *
@@ -449,19 +496,20 @@
 		final Rectangle clientArea = this.getClientArea();
 		if (isEnabled()) {
 			gc.setForeground(getForeground());
-		} else {
+		}
+		else {
 			gc.setForeground(getDisplay().getSystemColor(SWT.COLOR_GRAY));
 		}
-
+		
 		final float pixelSize = computePixelSizeForHorizonalSlider();
 		for (int i = 1; i < 10; i++) {
 			final int x = (int) (9 + pixelSize * (this.maximum - this.minimum) / 10 * i);
 			gc.drawLine(x, 4, x, 7);
 			gc.drawLine(x, clientArea.height - 6, x, clientArea.height - 9);
 		}
-
+		
 	}
-
+	
 	/**
 	 * Draws an horizontal knob
 	 *
@@ -478,38 +526,47 @@
 		if (knob == SELECTED_KNOB.UPPER) {
 			if (this.upperHover) {
 				image = this.dragInProgress ? this.sliderDrag : this.sliderHover;
-			} else if (this.lastSelected == SELECTED_KNOB.UPPER) {
+			}
+			else if (this.lastSelected == SELECTED_KNOB.UPPER) {
 				image = this.sliderSelected;
-			} else {
+			}
+			else {
 				image = this.slider;
 			}
-		} else if (knob == SELECTED_KNOB.LOWER) {
+		}
+		else if (knob == SELECTED_KNOB.LOWER) {
 			if (this.lowerHover) {
 				image = this.dragInProgress ? this.sliderDrag : this.sliderHover;
-			} else if (this.lastSelected == SELECTED_KNOB.LOWER) {
+			}
+			else if (this.lastSelected == SELECTED_KNOB.LOWER) {
 				image = this.sliderSelected;
-			} else {
+			}
+			else {
 				image = this.slider;
 			}
-		} else {
+		}
+		else {
 			if (this.middleHover) {
 				image = this.dragInProgress ? this.sliderDrag : this.sliderHover;
-			} else if (this.lastSelected == SELECTED_KNOB.MIDDLE) {
+			}
+			else if (this.lastSelected == SELECTED_KNOB.MIDDLE) {
 				image = this.sliderSelected;
-			} else {
+			}
+			else {
 				image = this.slider;
 			}
 		}
 		if (isEnabled()) {
 			gc.drawImage(image, x + 5, getClientArea().height / 2 - this.slider.getBounds().height / 2);
-		} else {
+		}
+		else {
 			final Image temp = new Image(getDisplay(), image, SWT.IMAGE_DISABLE);
 			gc.drawImage(temp, x + 5, getClientArea().height / 2 - this.slider.getBounds().height / 2);
 			temp.dispose();
 		}
 		return new Point(x + 5, getClientArea().height / 2 - this.slider.getBounds().height / 2);
 	}
-
+	
 	/**
 	 * Draw the range slider (vertical)
 	 *
@@ -522,7 +579,7 @@
 		this.coordMiddle = drawVerticalKnob(gc, this.middleValue, SELECTED_KNOB.MIDDLE);
 		this.coordLower = drawVerticalKnob(gc, this.lowerValue, SELECTED_KNOB.LOWER);
 	}
-
+	
 	/**
 	 * Draws the background
 	 *
@@ -532,33 +589,35 @@
 		final Rectangle clientArea = this.getClientArea();
 		gc.setBackground(getBackground());
 		gc.fillRectangle(clientArea);
-
+		
 		if (isEnabled()) {
 			gc.setForeground(getForeground());
-		} else {
+		}
+		else {
 			gc.setForeground(getDisplay().getSystemColor(SWT.COLOR_GRAY));
 		}
 		gc.drawRoundRectangle(9, 9, clientArea.width - 20, clientArea.height - 20, 3, 3);
-
+		
 		final float pixelSize = computePixelSizeForVerticalSlider();
 		final int startY = (int) (pixelSize * this.lowerValue);
 		final int endY = (int) (pixelSize * this.upperValue);
 		if (isEnabled()) {
 			gc.setBackground(getForeground());
-		} else {
+		}
+		else {
 			gc.setBackground(getDisplay().getSystemColor(SWT.COLOR_GRAY));
 		}
 		gc.fillRectangle(9, 12 + startY, clientArea.width - 20, endY - startY - 6);
-
+		
 	}
-
+	
 	/**
 	 * @return how many pixels corresponds to 1 point of value
 	 */
 	private float computePixelSizeForVerticalSlider() {
 		return (getClientArea().height - 20f) / (this.maximum - this.minimum);
 	}
-
+	
 	/**
 	 * Draws the bars
 	 *
@@ -568,20 +627,21 @@
 		final Rectangle clientArea = this.getClientArea();
 		if (isEnabled()) {
 			gc.setForeground(getForeground());
-		} else {
+		}
+		else {
 			gc.setForeground(getDisplay().getSystemColor(SWT.COLOR_GRAY));
 		}
-
+		
 		final float pixelSize = computePixelSizeForVerticalSlider();
 		for (int i = 1; i < 10; i++) {
 			final int y = (int) (9 + pixelSize * (this.maximum - this.minimum) / 10 * i);
 			gc.drawLine(4, y, 7, y);
 			gc.drawLine(clientArea.width - 6, y, clientArea.width - 9, y);
-
+			
 		}
-
+		
 	}
-
+	
 	/**
 	 * Draws a vertical knob
 	 *
@@ -594,133 +654,156 @@
 	private Point drawVerticalKnob(final GC gc, final int value, final SELECTED_KNOB knob) {
 		final float pixelSize = computePixelSizeForVerticalSlider();
 		final int y = (int) (pixelSize * value);
-
+		
 		Image image;
 		if (knob == SELECTED_KNOB.UPPER) {
 			if (this.upperHover) {
 				image = this.dragInProgress ? this.vSliderDrag : this.vSliderHover;
-			} else if (this.lastSelected == SELECTED_KNOB.UPPER) {
+			}
+			else if (this.lastSelected == SELECTED_KNOB.UPPER) {
 				image = this.vSliderSelected;
-			} else {
+			}
+			else {
 				image = this.vSlider;
 			}
-		} else if (knob == SELECTED_KNOB.LOWER) {
+		}
+		else if (knob == SELECTED_KNOB.LOWER) {
 			if (this.lowerHover) {
 				image = this.dragInProgress ? this.vSliderDrag : this.vSliderHover;
-			} else if (this.lastSelected == SELECTED_KNOB.LOWER) {
+			}
+			else if (this.lastSelected == SELECTED_KNOB.LOWER) {
 				image = this.vSliderSelected;
-			} else {
+			}
+			else {
 				image = this.vSlider;
 			}
-		} else { // MIDDLE
+		}
+		else { // MIDDLE
 			if (this.middleHover) {
 				image = this.dragInProgress ? this.vSliderDrag : this.vSliderHover;
-			} else if (this.lastSelected == SELECTED_KNOB.MIDDLE) {
+			}
+			else if (this.lastSelected == SELECTED_KNOB.MIDDLE) {
 				image = this.vSliderSelected;
-			} else {
+			}
+			else {
 				image = this.vSlider;
 			}
 		}
 		if (isEnabled()) {
 			gc.drawImage(image, getClientArea().width / 2 - 8, y + 2);
-		} else {
+		}
+		else {
 			final Image temp = new Image(getDisplay(), image, SWT.IMAGE_DISABLE);
 			gc.drawImage(temp, getClientArea().width / 2 - 8, y + 2);
 			temp.dispose();
 		}
 		return new Point(getClientArea().width / 2 - 8, y + 2);
 	}
-
+	
 	/**
 	 * Code executed when a key is typed
 	 *
 	 * @param event event
 	 */
 	private void handleKeyDown(final Event event) {
-
+		
 		boolean needRedraw = false;
-
+		
 		if (this.lastSelected == SELECTED_KNOB.NONE) {
 			this.lastSelected = SELECTED_KNOB.LOWER;
 		}
-
+		
 		switch (event.keyCode) {
-		case SWT.HOME:
-			if (this.lastSelected == SELECTED_KNOB.UPPER) {
-				this.upperValue = this.minimum;
-			} else if (this.lastSelected == SELECTED_KNOB.LOWER) {
-				this.lowerValue = this.minimum;
-			} else {
-				this.middleValue = this.minimum;
-			}
-			needRedraw = true;
-			break;
-		case SWT.END:
-			if (this.lastSelected == SELECTED_KNOB.UPPER) {
-				this.upperValue = this.maximum;
-			} if (this.lastSelected == SELECTED_KNOB.LOWER) {
-				this.lowerValue = this.maximum;
-			} else {
-				this.middleValue = this.maximum;
-			}
-			needRedraw = true;
-			break;
-		case SWT.PAGE_UP:
-			if (this.lastSelected == SELECTED_KNOB.UPPER) {
-				this.upperValue += this.pageIncrement;
-			} else if (this.lastSelected == SELECTED_KNOB.LOWER) {
-				this.lowerValue += this.pageIncrement;
-			} else {
-				this.middleValue += this.pageIncrement;
-			}
-			needRedraw = true;
-			break;
-		case SWT.PAGE_DOWN:
-			if (this.lastSelected == SELECTED_KNOB.UPPER) {
-				this.upperValue -= this.pageIncrement;
-			} else if (this.lastSelected == SELECTED_KNOB.LOWER) {
-				this.lowerValue -= this.pageIncrement;
-			} else {
-				this.middleValue -= this.pageIncrement;
-			}
-			needRedraw = true;
-			break;
-		case SWT.ARROW_LEFT:
-		case SWT.ARROW_UP:
-			if (this.lastSelected == SELECTED_KNOB.UPPER) {
-				this.upperValue -= this.increment;
-			} else if (this.lastSelected == SELECTED_KNOB.LOWER) {
-				this.lowerValue -= this.increment;
-			} else {
-				this.middleValue -= this.increment;
-			}
-			needRedraw = true;
-			break;
-		case SWT.ARROW_RIGHT:
-		case SWT.ARROW_DOWN:
-			if (this.lastSelected == SELECTED_KNOB.UPPER) {
-				this.upperValue += this.increment;
-			} else if (this.lastSelected == SELECTED_KNOB.LOWER) {
-				this.lowerValue += this.increment;
-			} else {
-				this.middleValue += this.increment;
-			}
-			needRedraw = true;
-			break;
+			case SWT.HOME:
+				if (this.lastSelected == SELECTED_KNOB.UPPER) {
+					this.upperValue = this.minimum;
+				}
+				else if (this.lastSelected == SELECTED_KNOB.LOWER) {
+					this.lowerValue = this.minimum;
+				}
+				else {
+					this.middleValue = this.minimum;
+				}
+				needRedraw = true;
+				break;
+			case SWT.END:
+				if (this.lastSelected == SELECTED_KNOB.UPPER) {
+					this.upperValue = this.maximum;
+				}
+				if (this.lastSelected == SELECTED_KNOB.LOWER) {
+					this.lowerValue = this.maximum;
+				}
+				else {
+					this.middleValue = this.maximum;
+				}
+				needRedraw = true;
+				break;
+			case SWT.PAGE_UP:
+				if (this.lastSelected == SELECTED_KNOB.UPPER) {
+					this.upperValue += this.pageIncrement;
+				}
+				else if (this.lastSelected == SELECTED_KNOB.LOWER) {
+					this.lowerValue += this.pageIncrement;
+				}
+				else {
+					this.middleValue += this.pageIncrement;
+				}
+				needRedraw = true;
+				break;
+			case SWT.PAGE_DOWN:
+				if (this.lastSelected == SELECTED_KNOB.UPPER) {
+					this.upperValue -= this.pageIncrement;
+				}
+				else if (this.lastSelected == SELECTED_KNOB.LOWER) {
+					this.lowerValue -= this.pageIncrement;
+				}
+				else {
+					this.middleValue -= this.pageIncrement;
+				}
+				needRedraw = true;
+				break;
+			case SWT.ARROW_LEFT:
+			case SWT.ARROW_UP:
+				if (this.lastSelected == SELECTED_KNOB.UPPER) {
+					this.upperValue -= this.increment;
+				}
+				else if (this.lastSelected == SELECTED_KNOB.LOWER) {
+					this.lowerValue -= this.increment;
+				}
+				else {
+					this.middleValue -= this.increment;
+				}
+				needRedraw = true;
+				break;
+			case SWT.ARROW_RIGHT:
+			case SWT.ARROW_DOWN:
+				if (this.lastSelected == SELECTED_KNOB.UPPER) {
+					this.upperValue += this.increment;
+				}
+				else if (this.lastSelected == SELECTED_KNOB.LOWER) {
+					this.lowerValue += this.increment;
+				}
+				else {
+					this.middleValue += this.increment;
+				}
+				needRedraw = true;
+				break;
 		}
-
+		
 		if (needRedraw) {
 			if (this.lastSelected == SELECTED_KNOB.UPPER) {
 				checkUpperValue();
-			} else if (this.lastSelected == SELECTED_KNOB.LOWER) {
+			}
+			else if (this.lastSelected == SELECTED_KNOB.LOWER) {
 				checkLowerValue();
-			} else {
+			}
+			else {
 				checkMiddleValue();
 			}
 			redraw();
 		}
 	}
-
+	
 	/**
 	 * Adds the listener to the collection of listeners who will be notified
 	 * when the user changes the receiver's value, by sending it one of the
@@ -732,10 +815,12 @@
 	 *
 	 * @param listener the listener which should be notified
 	 *
-	 * @exception IllegalArgumentException <ul>
+	 * @exception IllegalArgumentException
+	 *                <ul>
 	 *                <li>ERROR_NULL_ARGUMENT - if the listener is null</li>
 	 *                </ul>
-	 * @exception SWTException <ul>
+	 * @exception SWTException
+	 *                <ul>
 	 *                <li>ERROR_WIDGET_DISPOSED - if the receiver has been
 	 *                disposed</li>
 	 *                <li>ERROR_THREAD_INVALID_ACCESS - if not called from the
@@ -749,7 +834,7 @@
 		checkWidget();
 		this.listeners.add(listener);
 	}
-
+	
 	/**
 	 * @see org.eclipse.swt.widgets.Composite#computeSize(int, int, boolean)
 	 */
@@ -760,39 +845,45 @@
 		if (this.orientation == SWT.HORIZONTAL) {
 			if (wHint < 100) {
 				width = 100;
-			} else {
+			}
+			else {
 				width = wHint;
 			}
-
+			
 			if (hHint < 30) {
 				height = 30;
-			} else {
+			}
+			else {
 				height = hHint;
 			}
-		} else {
+		}
+		else {
 			if (wHint < 30) {
 				width = 30;
-			} else {
+			}
+			else {
 				width = wHint;
 			}
-
+			
 			if (hHint < 100) {
 				height = 100;
-			} else {
+			}
+			else {
 				height = hHint;
 			}
 		}
-
+		
 		return new Point(width, height);
 	}
-
+	
 	/**
 	 * Returns the amount that the selected receiver's value will be modified by
 	 * when the up/down (or right/left) arrows are pressed.
 	 *
 	 * @return the increment
 	 *
-	 * @exception SWTException <ul>
+	 * @exception SWTException
+	 *                <ul>
 	 *                <li>ERROR_WIDGET_DISPOSED - if the receiver has been
 	 *                disposed</li>
 	 *                <li>ERROR_THREAD_INVALID_ACCESS - if not called from the
@@ -803,13 +894,14 @@
 		checkWidget();
 		return this.increment;
 	}
-
+	
 	/**
 	 * Returns the 'lower selection', which is the lower receiver's position.
 	 *
 	 * @return the selection
 	 *
-	 * @exception SWTException <ul>
+	 * @exception SWTException
+	 *                <ul>
 	 *                <li>ERROR_WIDGET_DISPOSED - if the receiver has been
 	 *                disposed</li>
 	 *                <li>ERROR_THREAD_INVALID_ACCESS - if not called from the
@@ -824,13 +916,14 @@
 	public SELECTED_KNOB getLastSelectedKnob() {
 		return lastSelected;
 	}
-
+	
 	/**
 	 * Returns the 'middle selection', which is the middle receiver's position.
 	 *
 	 * @return the selection
 	 *
-	 * @exception SWTException <ul>
+	 * @exception SWTException
+	 *                <ul>
 	 *                <li>ERROR_WIDGET_DISPOSED - if the receiver has been
 	 *                disposed</li>
 	 *                <li>ERROR_THREAD_INVALID_ACCESS - if not called from the
@@ -847,7 +940,8 @@
 	 *
 	 * @return the maximum
 	 *
-	 * @exception SWTException <ul>
+	 * @exception SWTException
+	 *                <ul>
 	 *                <li>ERROR_WIDGET_DISPOSED - if the receiver has been
 	 *                disposed</li>
 	 *                <li>ERROR_THREAD_INVALID_ACCESS - if not called from the
@@ -858,13 +952,14 @@
 		checkWidget();
 		return this.maximum;
 	}
-
+	
 	/**
 	 * Returns the minimum value which the receiver will allow.
 	 *
 	 * @return the minimum
 	 *
-	 * @exception SWTException <ul>
+	 * @exception SWTException
+	 *                <ul>
 	 *                <li>ERROR_WIDGET_DISPOSED - if the receiver has been
 	 *                disposed</li>
 	 *                <li>ERROR_THREAD_INVALID_ACCESS - if not called from the
@@ -875,14 +970,15 @@
 		checkWidget();
 		return this.minimum;
 	}
-
+	
 	/**
 	 * Returns the amount that the selected receiver's value will be modified by
 	 * when the page increment/decrement areas are selected.
 	 *
 	 * @return the page increment
 	 *
-	 * @exception SWTException <ul>
+	 * @exception SWTException
+	 *                <ul>
 	 *                <li>ERROR_WIDGET_DISPOSED - if the receiver has been
 	 *                disposed</li>
 	 *                <li>ERROR_THREAD_INVALID_ACCESS - if not called from the
@@ -893,14 +989,15 @@
 		checkWidget();
 		return this.pageIncrement;
 	}
-
+	
 	/**
 	 * Returns the 'selection', which is an array where the first element is the
 	 * lower selection, and the second element is the upper selection
 	 *
 	 * @return the selection
 	 *
-	 * @exception SWTException <ul>
+	 * @exception SWTException
+	 *                <ul>
 	 *                <li>ERROR_WIDGET_DISPOSED - if the receiver has been
 	 *                disposed</li>
 	 *                <li>ERROR_THREAD_INVALID_ACCESS - if not called from the
@@ -915,13 +1012,14 @@
 		selection[2] = this.upperValue;
 		return selection;
 	}
-
+	
 	/**
 	 * Returns the 'upper selection', which is the upper receiver's position.
 	 *
 	 * @return the selection
 	 *
-	 * @exception SWTException <ul>
+	 * @exception SWTException
+	 *                <ul>
 	 *                <li>ERROR_WIDGET_DISPOSED - if the receiver has been
 	 *                disposed</li>
 	 *                <li>ERROR_THREAD_INVALID_ACCESS - if not called from the
@@ -932,17 +1030,19 @@
 		checkWidget();
 		return this.upperValue;
 	}
-
+	
 	/**
 	 * Removes the listener from the collection of listeners who will be
 	 * notified when the user changes the receiver's value.
 	 *
 	 * @param listener the listener which should no longer be notified
 	 *
-	 * @exception IllegalArgumentException <ul>
+	 * @exception IllegalArgumentException
+	 *                <ul>
 	 *                <li>ERROR_NULL_ARGUMENT - if the listener is null</li>
 	 *                </ul>
-	 * @exception SWTException <ul>
+	 * @exception SWTException
+	 *                <ul>
 	 *                <li>ERROR_WIDGET_DISPOSED - if the receiver has been
 	 *                disposed</li>
 	 *                <li>ERROR_THREAD_INVALID_ACCESS - if not called from the
@@ -956,7 +1056,7 @@
 		checkWidget();
 		this.listeners.remove(listener);
 	}
-
+	
 	/**
 	 * Sets the amount that the selected receiver's value will be modified by
 	 * when the up/down (or right/left) arrows are pressed to the argument,
@@ -964,7 +1064,8 @@
 	 *
 	 * @param increment the new increment (must be greater than zero)
 	 *
-	 * @exception SWTException <ul>
+	 * @exception SWTException
+	 *                <ul>
 	 *                <li>ERROR_WIDGET_DISPOSED - if the receiver has been
 	 *                disposed</li>
 	 *                <li>ERROR_THREAD_INVALID_ACCESS - if not called from the
@@ -976,14 +1077,15 @@
 		this.increment = increment;
 		redraw();
 	}
-
+	
 	/**
 	 * Sets the 'lower selection', which is the receiver's lower value, to the
 	 * argument which must be greater than or equal to zero.
 	 *
 	 * @param value the new selection (must be zero or greater)
 	 *
-	 * @exception SWTException <ul>
+	 * @exception SWTException
+	 *                <ul>
 	 *                <li>ERROR_WIDGET_DISPOSED - if the receiver has been
 	 *                disposed</li>
 	 *                <li>ERROR_THREAD_INVALID_ACCESS - if not called from the
@@ -1000,7 +1102,7 @@
 		
 		redraw();
 	}
-
+	
 	/**
 	 * Sets the maximum value that the receiver will allow. This new value will
 	 * be ignored if it is not greater than the receiver's current minimum
@@ -1010,7 +1112,8 @@
 	 * @param value the new maximum, which must be greater than the current
 	 *            minimum
 	 *
-	 * @exception SWTException <ul>
+	 * @exception SWTException
+	 *                <ul>
 	 *                <li>ERROR_WIDGET_DISPOSED - if the receiver has been
 	 *                disposed</li>
 	 *                <li>ERROR_THREAD_INVALID_ACCESS - if not called from the
@@ -1033,7 +1136,7 @@
 		}
 		redraw();
 	}
-
+	
 	/**
 	 * Sets the minimum value that the receiver will allow. This new value will
 	 * be ignored if it is negative or is not less than the receiver's current
@@ -1044,7 +1147,8 @@
 	 * @param value the new minimum, which must be nonnegative and less than the
 	 *            current maximum
 	 *
-	 * @exception SWTException <ul>
+	 * @exception SWTException
+	 *                <ul>
 	 *                <li>ERROR_WIDGET_DISPOSED - if the receiver has been
 	 *                disposed</li>
 	 *                <li>ERROR_THREAD_INVALID_ACCESS - if not called from the
@@ -1067,7 +1171,7 @@
 		}
 		redraw();
 	}
-
+	
 	/**
 	 * Sets the amount that the receiver's value will be modified by when the
 	 * page increment/decrement areas are selected to the argument, which must
@@ -1075,7 +1179,8 @@
 	 *
 	 * @param pageIncrement the page increment (must be greater than zero)
 	 *
-	 * @exception SWTException <ul>
+	 * @exception SWTException
+	 *                <ul>
 	 *                <li>ERROR_WIDGET_DISPOSED - if the receiver has been
 	 *                disposed</li>
 	 *                <li>ERROR_THREAD_INVALID_ACCESS - if not called from the
@@ -1086,7 +1191,7 @@
 		checkWidget();
 		this.pageIncrement = pageIncrement;
 	}
-
+	
 	/**
 	 * Sets the 'selection', which is the receiver's value, to the argument
 	 * which must be greater than or equal to zero.
@@ -1094,7 +1199,8 @@
 	 * @param value the new selection (first value is lower value, second value
 	 *            is upper value)
 	 *
-	 * @exception SWTException <ul>
+	 * @exception SWTException
+	 *                <ul>
 	 *                <li>ERROR_WIDGET_DISPOSED - if the receiver has been
 	 *                disposed</li>
 	 *                <li>ERROR_THREAD_INVALID_ACCESS - if not called from the
@@ -1103,7 +1209,7 @@
 	 */
 	public void setSelection(final int[] values) {
 		if (values.length != 3) return;
-	
+		
 		checkWidget();
 		setLowerValue(values[0]);
 		setMiddleValue(values[1]);
@@ -1113,7 +1219,7 @@
 		checkMiddleValue();
 		redraw();
 	}
-
+	
 	/**
 	 * Sets the 'selection', which is the receiver's value, argument which must
 	 * be greater than or equal to zero.
